//******************************************************************************
//
// Copyright (c) 2016 Microsoft Corporation. All rights reserved.
//
// This code is licensed under the MIT License (MIT).
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//
//******************************************************************************

#import <AVFoundation/AVFoundation.h>

#import <StubReturn.h>
#import "AssertARCEnabled.h"

NSString* const AVFormatIDKey = @"AVFormatIDKey";
NSString* const AVSampleRateKey = @"AVSampleRateKey";
NSString* const AVNumberOfChannelsKey = @"AVNumberOfChannelsKey";
NSString* const AVLinearPCMBitDepthKey = @"AVLinearPCMBitDepthKey";
NSString* const AVLinearPCMIsBigEndianKey = @"AVLinearPCMIsBigEndianKey";
NSString* const AVLinearPCMIsFloatKey = @"AVLinearPCMIsFloatKey";
NSString* const AVLinearPCMIsNonInterleaved = @"AVLinearPCMIsNonInterleaved";
NSString* const AVEncoderAudioQualityKey = @"AVEncoderAudioQualityKey";
NSString* const AVEncoderBitRateKey = @"AVEncoderBitRateKey";
NSString* const AVEncoderBitRatePerChannelKey = @"AVEncoderBitRatePerChannelKey";
NSString* const AVEncoderBitRateStrategyKey = @"AVEncoderBitRateStrategyKey";
NSString* const AVEncoderBitDepthHintKey = @"AVEncoderBitDepthHintKey";
NSString* const AVSampleRateConverterAudioQualityKey = @"AVSampleRateConverterAudioQualityKey";
NSString* const AVEncoderAudioQualityForVBRKey = @"AVEncoderAudioQualityForVBRKey";
NSString* const AVSampleRateConverterAlgorithmKey = @"AVSampleRateConverterAlgorithmKey";
NSString* const AVAudioBitRateStrategy_Constant = @"AVAudioBitRateStrategy_Constant";
NSString* const AVAudioBitRateStrategy_LongTermAverage = @"AVAudioBitRateStrategy_LongTermAverage";
NSString* const AVAudioBitRateStrategy_VariableConstrained = @"AVAudioBitRateStrategy_VariableConstrained";
NSString* const AVAudioBitRateStrategy_Variable = @"AVAudioBitRateStrategy_Variable";
NSString* const AVSampleRateConverterAlgorithm_Normal = @"AVSampleRateConverterAlgorithm_Normal";
NSString* const AVSampleRateConverterAlgorithm_Mastering = @"AVSampleRateConverterAlgorithm_Mastering";
NSString* const AVAudioTimePitchAlgorithmLowQualityZeroLatency = @"AVAudioTimePitchAlgorithmLowQualityZeroLatency";
NSString* const AVAudioTimePitchAlgorithmTimeDomain = @"AVAudioTimePitchAlgorithmTimeDomain";
NSString* const AVAudioTimePitchAlgorithmSpectral = @"AVAudioTimePitchAlgorithmSpectral";
NSString* const AVAudioTimePitchAlgorithmVarispeed = @"AVAudioTimePitchAlgorithmVarispeed";
NSString* const AVChannelLayoutKey = @"AVChannelLayoutKey";
NSString* const AVMediaTypeVideo = @"AVMediaTypeVideo";
NSString* const AVMediaTypeAudio = @"AVMediaTypeAudio";
NSString* const AVMediaTypeText = @"AVMediaTypeText";
NSString* const AVMediaTypeClosedCaption = @"AVMediaTypeClosedCaption";
NSString* const AVMediaTypeSubtitle = @"AVMediaTypeSubtitle";
NSString* const AVMediaTypeTimecode = @"AVMediaTypeTimecode";
NSString* const AVMediaTypeTimedMetadata = @"AVMediaTypeTimedMetadata";
NSString* const AVMediaTypeMetadata = @"AVMediaTypeMetadata";
NSString* const AVMediaTypeMuxed = @"AVMediaTypeMuxed";
NSString* const AVLayerVideoGravityResize = @"AVLayerVideoGravityResize";
NSString* const AVLayerVideoGravityResizeAspect = @"AVLayerVideoGravityResizeAspect";
NSString* const AVLayerVideoGravityResizeAspectFill = @"AVLayerVideoGravityResizeAspectFill";
NSString* const AVMediaCharacteristicVisual = @"AVMediaCharacteristicVisual";
NSString* const AVMediaCharacteristicAudible = @"AVMediaCharacteristicAudible";
NSString* const AVMediaCharacteristicLegible = @"AVMediaCharacteristicLegible";
NSString* const AVMediaCharacteristicFrameBased = @"AVMediaCharacteristicFrameBased";
NSString* const AVVideoCodecKey = @"AVVideoCodecKey";
NSString* const AVVideoCodecH264 = @"AVVideoCodecH264";
NSString* const AVVideoCodecJPEG = @"AVVideoCodecJPEG";
NSString* const AVVideoWidthKey = @"AVVideoWidthKey";
NSString* const AVVideoHeightKey = @"AVVideoHeightKey";
NSString* const AVVideoCompressionPropertiesKey = @"AVVideoCompressionPropertiesKey";
NSString* const AVVideoAverageBitRateKey = @"AVVideoAverageBitRateKey";
NSString* const AVVideoQualityKey = @"AVVideoQualityKey";
NSString* const AVVideoMaxKeyFrameIntervalKey = @"AVVideoMaxKeyFrameIntervalKey";
NSString* const AVVideoProfileLevelKey = @"AVVideoProfileLevelKey";
NSString* const AVVideoProfileLevelH264Baseline30 = @"AVVideoProfileLevelH264Baseline30";
NSString* const AVVideoProfileLevelH264Baseline31 = @"AVVideoProfileLevelH264Baseline31";
NSString* const AVVideoProfileLevelH264Baseline41 = @"AVVideoProfileLevelH264Baseline41";
NSString* const AVVideoProfileLevelH264Main30 = @"AVVideoProfileLevelH264Main30";
NSString* const AVVideoProfileLevelH264Main31 = @"AVVideoProfileLevelH264Main31";
NSString* const AVVideoProfileLevelH264Main32 = @"AVVideoProfileLevelH264Main32";
NSString* const AVVideoProfileLevelH264Main41 = @"AVVideoProfileLevelH264Main41";
NSString* const AVVideoProfileLevelH264High40 = @"AVVideoProfileLevelH264High40";
NSString* const AVVideoProfileLevelH264High41 = @"AVVideoProfileLevelH264High41";
NSString* const AVVideoPixelAspectRatioKey = @"AVVideoPixelAspectRatioKey";
NSString* const AVVideoPixelAspectRatioHorizontalSpacingKey = @"AVVideoPixelAspectRatioHorizontalSpacingKey";
NSString* const AVVideoPixelAspectRatioVerticalSpacingKey = @"AVVideoPixelAspectRatioVerticalSpacingKey";
NSString* const AVVideoCleanApertureKey = @"AVVideoCleanApertureKey";
NSString* const AVVideoCleanApertureWidthKey = @"AVVideoCleanApertureWidthKey";
NSString* const AVVideoCleanApertureHeightKey = @"AVVideoCleanApertureHeightKey";
NSString* const AVVideoCleanApertureHorizontalOffsetKey = @"AVVideoCleanApertureHorizontalOffsetKey";
NSString* const AVVideoCleanApertureVerticalOffsetKey = @"AVVideoCleanApertureVerticalOffsetKey";
NSString* const AVFileType3GPP = @"AVFileType3GPP";
NSString* const AVFileType3GPP2 = @"AVFileType3GPP2";
NSString* const AVFileTypeAIFC = @"AVFileTypeAIFC";
NSString* const AVFileTypeAIFF = @"AVFileTypeAIFF";
NSString* const AVFileTypeAMR = @"AVFileTypeAMR";
NSString* const AVFileTypeAC3 = @"AVFileTypeAC3";
NSString* const AVFileTypeMPEGLayer3 = @"AVFileTypeMPEGLayer3";
NSString* const AVFileTypeSunAU = @"AVFileTypeSunAU";
NSString* const AVFileTypeCoreAudioFormat = @"AVFileTypeCoreAudioFormat";
NSString* const AVFileTypeAppleM4V = @"AVFileTypeAppleM4V";
NSString* const AVFileTypeMPEG4 = @"AVFileTypeMPEG4";
NSString* const AVFileTypeAppleM4A = @"AVFileTypeAppleM4A";
NSString* const AVFileTypeQuickTimeMovie = @"AVFileTypeQuickTimeMovie";
NSString* const AVFileTypeWAVE = @"AVFileTypeWAVE";
/** @Status Stub */
const CFTimeInterval AVCoreAnimationBeginTimeAtZero = StubConstant();
NSString* const AVVideoScalingModeKey = @"AVVideoScalingModeKey";
NSString* const AVVideoScalingModeFit = @"AVVideoScalingModeFit";
NSString* const AVVideoScalingModeResize = @"AVVideoScalingModeResize";
NSString* const AVVideoScalingModeResizeAspect = @"AVVideoScalingModeResizeAspect";
NSString* const AVVideoScalingModeResizeAspectFill = @"AVVideoScalingModeResizeAspectFill";
NSString* const AVMediaCharacteristicIsMainProgramContent = @"AVMediaCharacteristicIsMainProgramContent";
NSString* const AVMediaCharacteristicIsAuxiliaryContent = @"AVMediaCharacteristicIsAuxiliaryContent";
NSString* const AVMediaCharacteristicContainsOnlyForcedSubtitles = @"AVMediaCharacteristicContainsOnlyForcedSubtitles";
NSString* const AVMediaCharacteristicTranscribesSpokenDialogForAccessibility =
    @"AVMediaCharacteristicTranscribesSpokenDialogForAccessibility";
NSString* const AVMediaCharacteristicDescribesMusicAndSoundForAccessibility =
    @"AVMediaCharacteristicDescribesMusicAndSoundForAccessibility";
NSString* const AVMediaCharacteristicDescribesVideoForAccessibility = @"AVMediaCharacteristicDescribesVideoForAccessibility";
NSString* const AVMediaCharacteristicEasyToRead = @"AVMediaCharacteristicEasyToRead";
const NSString* AVFoundationErrorDomain = @"AVFoundationErrorDomain";
NSString* const AVErrorDeviceKey = @"AVErrorDeviceKey";
NSString* const AVErrorTimeKey = @"AVErrorTimeKey";
NSString* const AVErrorFileSizeKey = @"AVErrorFileSizeKey";
NSString* const AVErrorPIDKey = @"AVErrorPIDKey";
NSString* const AVErrorRecordingSuccessfullyFinishedKey = @"AVErrorRecordingSuccessfullyFinishedKey";
NSString* const AVErrorMediaTypeKey = @"AVErrorMediaTypeKey";
NSString* const AVErrorMediaSubTypeKey = @"AVErrorMediaSubTypeKey";
NSString* const AVMetadataKeySpaceCommon = @"AVMetadataKeySpaceCommon";
NSString* const AVMetadataKeySpaceID3 = @"AVMetadataKeySpaceID3";
NSString* const AVMetadataKeySpaceiTunes = @"AVMetadataKeySpaceiTunes";
NSString* const AVMetadataKeySpaceQuickTimeUserData = @"AVMetadataKeySpaceQuickTimeUserData";
NSString* const AVMetadataKeySpaceQuickTimeMetadata = @"AVMetadataKeySpaceQuickTimeMetadata";
NSString* const AVMetadataFormatID3Metadata = @"AVMetadataFormatID3Metadata";
NSString* const AVMetadataFormatiTunesMetadata = @"AVMetadataFormatiTunesMetadata";
NSString* const AVMetadataFormatQuickTimeUserData = @"AVMetadataFormatQuickTimeUserData";
NSString* const AVMetadataFormatQuickTimeMetadata = @"AVMetadataFormatQuickTimeMetadata";
NSString* const AVMetadataCommonKeyTitle = @"AVMetadataCommonKeyTitle";
NSString* const AVMetadataCommonKeyCreator = @"AVMetadataCommonKeyCreator";
NSString* const AVMetadataCommonKeySubject = @"AVMetadataCommonKeySubject";
NSString* const AVMetadataCommonKeyDescription = @"AVMetadataCommonKeyDescription";
NSString* const AVMetadataCommonKeyPublisher = @"AVMetadataCommonKeyPublisher";
NSString* const AVMetadataCommonKeyContributor = @"AVMetadataCommonKeyContributor";
NSString* const AVMetadataCommonKeyCreationDate = @"AVMetadataCommonKeyCreationDate";
NSString* const AVMetadataCommonKeyLastModifiedDate = @"AVMetadataCommonKeyLastModifiedDate";
NSString* const AVMetadataCommonKeyType = @"AVMetadataCommonKeyType";
NSString* const AVMetadataCommonKeyFormat = @"AVMetadataCommonKeyFormat";
NSString* const AVMetadataCommonKeyIdentifier = @"AVMetadataCommonKeyIdentifier";
NSString* const AVMetadataCommonKeySource = @"AVMetadataCommonKeySource";
NSString* const AVMetadataCommonKeyLanguage = @"AVMetadataCommonKeyLanguage";
NSString* const AVMetadataCommonKeyRelation = @"AVMetadataCommonKeyRelation";
NSString* const AVMetadataCommonKeyLocation = @"AVMetadataCommonKeyLocation";
NSString* const AVMetadataCommonKeyCopyrights = @"AVMetadataCommonKeyCopyrights";
NSString* const AVMetadataCommonKeyAlbumName = @"AVMetadataCommonKeyAlbumName";
NSString* const AVMetadataCommonKeyAuthor = @"AVMetadataCommonKeyAuthor";
NSString* const AVMetadataCommonKeyArtist = @"AVMetadataCommonKeyArtist";
NSString* const AVMetadataCommonKeyArtwork = @"AVMetadataCommonKeyArtwork";
NSString* const AVMetadataCommonKeyMake = @"AVMetadataCommonKeyMake";
NSString* const AVMetadataCommonKeyModel = @"AVMetadataCommonKeyModel";
NSString* const AVMetadataCommonKeySoftware = @"AVMetadataCommonKeySoftware";
NSString* const AVMetadataID3MetadataKeyAudioEncryption = @"AVMetadataID3MetadataKeyAudioEncryption";
NSString* const AVMetadataID3MetadataKeyAttachedPicture = @"AVMetadataID3MetadataKeyAttachedPicture";
NSString* const AVMetadataID3MetadataKeyAudioSeekPointIndex = @"AVMetadataID3MetadataKeyAudioSeekPointIndex";
NSString* const AVMetadataID3MetadataKeyComments = @"AVMetadataID3MetadataKeyComments";
NSString* const AVMetadataID3MetadataKeyCommerical = @"AVMetadataID3MetadataKeyCommerical";
NSString* const AVMetadataID3MetadataKeyEncryption = @"AVMetadataID3MetadataKeyEncryption";
NSString* const AVMetadataID3MetadataKeyEqualization = @"AVMetadataID3MetadataKeyEqualization";
NSString* const AVMetadataID3MetadataKeyEqualization2 = @"AVMetadataID3MetadataKeyEqualization2";
NSString* const AVMetadataID3MetadataKeyEventTimingCodes = @"AVMetadataID3MetadataKeyEventTimingCodes";
NSString* const AVMetadataID3MetadataKeyGeneralEncapsulatedObject = @"AVMetadataID3MetadataKeyGeneralEncapsulatedObject";
NSString* const AVMetadataID3MetadataKeyGroupIdentifier = @"AVMetadataID3MetadataKeyGroupIdentifier";
NSString* const AVMetadataID3MetadataKeyInvolvedPeopleList_v23 = @"AVMetadataID3MetadataKeyInvolvedPeopleList_v23";
NSString* const AVMetadataID3MetadataKeyLink = @"AVMetadataID3MetadataKeyLink";
NSString* const AVMetadataID3MetadataKeyMusicCDIdentifier = @"AVMetadataID3MetadataKeyMusicCDIdentifier";
NSString* const AVMetadataID3MetadataKeyMPEGLocationLookupTable = @"AVMetadataID3MetadataKeyMPEGLocationLookupTable";
NSString* const AVMetadataID3MetadataKeyOwnership = @"AVMetadataID3MetadataKeyOwnership";
NSString* const AVMetadataID3MetadataKeyPrivate = @"AVMetadataID3MetadataKeyPrivate";
NSString* const AVMetadataID3MetadataKeyPlayCounter = @"AVMetadataID3MetadataKeyPlayCounter";
NSString* const AVMetadataID3MetadataKeyPopularimeter = @"AVMetadataID3MetadataKeyPopularimeter";
NSString* const AVMetadataID3MetadataKeyPositionSynchronization = @"AVMetadataID3MetadataKeyPositionSynchronization";
NSString* const AVMetadataID3MetadataKeyRecommendedBufferSize = @"AVMetadataID3MetadataKeyRecommendedBufferSize";
NSString* const AVMetadataID3MetadataKeyRelativeVolumeAdjustment = @"AVMetadataID3MetadataKeyRelativeVolumeAdjustment";
NSString* const AVMetadataID3MetadataKeyRelativeVolumeAdjustment2 = @"AVMetadataID3MetadataKeyRelativeVolumeAdjustment2";
NSString* const AVMetadataID3MetadataKeyReverb = @"AVMetadataID3MetadataKeyReverb";
NSString* const AVMetadataID3MetadataKeySeek = @"AVMetadataID3MetadataKeySeek";
NSString* const AVMetadataID3MetadataKeySignature = @"AVMetadataID3MetadataKeySignature";
NSString* const AVMetadataID3MetadataKeySynchronizedLyric = @"AVMetadataID3MetadataKeySynchronizedLyric";
NSString* const AVMetadataID3MetadataKeySynchronizedTempoCodes = @"AVMetadataID3MetadataKeySynchronizedTempoCodes";
NSString* const AVMetadataID3MetadataKeyAlbumTitle = @"AVMetadataID3MetadataKeyAlbumTitle";
NSString* const AVMetadataID3MetadataKeyBeatsPerMinute = @"AVMetadataID3MetadataKeyBeatsPerMinute";
NSString* const AVMetadataID3MetadataKeyComposer = @"AVMetadataID3MetadataKeyComposer";
NSString* const AVMetadataID3MetadataKeyContentType = @"AVMetadataID3MetadataKeyContentType";
NSString* const AVMetadataID3MetadataKeyCopyright = @"AVMetadataID3MetadataKeyCopyright";
NSString* const AVMetadataID3MetadataKeyDate = @"AVMetadataID3MetadataKeyDate";
NSString* const AVMetadataID3MetadataKeyEncodingTime = @"AVMetadataID3MetadataKeyEncodingTime";
NSString* const AVMetadataID3MetadataKeyPlaylistDelay = @"AVMetadataID3MetadataKeyPlaylistDelay";
NSString* const AVMetadataID3MetadataKeyOriginalReleaseTime = @"AVMetadataID3MetadataKeyOriginalReleaseTime";
NSString* const AVMetadataID3MetadataKeyRecordingTime = @"AVMetadataID3MetadataKeyRecordingTime";
NSString* const AVMetadataID3MetadataKeyReleaseTime = @"AVMetadataID3MetadataKeyReleaseTime";
NSString* const AVMetadataID3MetadataKeyTaggingTime = @"AVMetadataID3MetadataKeyTaggingTime";
NSString* const AVMetadataID3MetadataKeyEncodedBy = @"AVMetadataID3MetadataKeyEncodedBy";
NSString* const AVMetadataID3MetadataKeyLyricist = @"AVMetadataID3MetadataKeyLyricist";
NSString* const AVMetadataID3MetadataKeyFileType = @"AVMetadataID3MetadataKeyFileType";
NSString* const AVMetadataID3MetadataKeyTime = @"AVMetadataID3MetadataKeyTime";
NSString* const AVMetadataID3MetadataKeyInvolvedPeopleList_v24 = @"AVMetadataID3MetadataKeyInvolvedPeopleList_v24";
NSString* const AVMetadataID3MetadataKeyContentGroupDescription = @"AVMetadataID3MetadataKeyContentGroupDescription";
NSString* const AVMetadataID3MetadataKeyTitleDescription = @"AVMetadataID3MetadataKeyTitleDescription";
NSString* const AVMetadataID3MetadataKeySubTitle = @"AVMetadataID3MetadataKeySubTitle";
NSString* const AVMetadataID3MetadataKeyInitialKey = @"AVMetadataID3MetadataKeyInitialKey";
NSString* const AVMetadataID3MetadataKeyLanguage = @"AVMetadataID3MetadataKeyLanguage";
NSString* const AVMetadataID3MetadataKeyLength = @"AVMetadataID3MetadataKeyLength";
NSString* const AVMetadataID3MetadataKeyMusicianCreditsList = @"AVMetadataID3MetadataKeyMusicianCreditsList";
NSString* const AVMetadataID3MetadataKeyMediaType = @"AVMetadataID3MetadataKeyMediaType";
NSString* const AVMetadataID3MetadataKeyMood = @"AVMetadataID3MetadataKeyMood";
NSString* const AVMetadataID3MetadataKeyOriginalAlbumTitle = @"AVMetadataID3MetadataKeyOriginalAlbumTitle";
NSString* const AVMetadataID3MetadataKeyOriginalFilename = @"AVMetadataID3MetadataKeyOriginalFilename";
NSString* const AVMetadataID3MetadataKeyOriginalLyricist = @"AVMetadataID3MetadataKeyOriginalLyricist";
NSString* const AVMetadataID3MetadataKeyOriginalArtist = @"AVMetadataID3MetadataKeyOriginalArtist";
NSString* const AVMetadataID3MetadataKeyOriginalReleaseYear = @"AVMetadataID3MetadataKeyOriginalReleaseYear";
NSString* const AVMetadataID3MetadataKeyFileOwner = @"AVMetadataID3MetadataKeyFileOwner";
NSString* const AVMetadataID3MetadataKeyLeadPerformer = @"AVMetadataID3MetadataKeyLeadPerformer";
NSString* const AVMetadataID3MetadataKeyBand = @"AVMetadataID3MetadataKeyBand";
NSString* const AVMetadataID3MetadataKeyConductor = @"AVMetadataID3MetadataKeyConductor";
NSString* const AVMetadataID3MetadataKeyModifiedBy = @"AVMetadataID3MetadataKeyModifiedBy";
NSString* const AVMetadataID3MetadataKeyPartOfASet = @"AVMetadataID3MetadataKeyPartOfASet";
NSString* const AVMetadataID3MetadataKeyProducedNotice = @"AVMetadataID3MetadataKeyProducedNotice";
NSString* const AVMetadataID3MetadataKeyPublisher = @"AVMetadataID3MetadataKeyPublisher";
NSString* const AVMetadataID3MetadataKeyTrackNumber = @"AVMetadataID3MetadataKeyTrackNumber";
NSString* const AVMetadataID3MetadataKeyRecordingDates = @"AVMetadataID3MetadataKeyRecordingDates";
NSString* const AVMetadataID3MetadataKeyInternetRadioStationName = @"AVMetadataID3MetadataKeyInternetRadioStationName";
NSString* const AVMetadataID3MetadataKeyInternetRadioStationOwner = @"AVMetadataID3MetadataKeyInternetRadioStationOwner";
NSString* const AVMetadataID3MetadataKeySize = @"AVMetadataID3MetadataKeySize";
NSString* const AVMetadataID3MetadataKeyAlbumSortOrder = @"AVMetadataID3MetadataKeyAlbumSortOrder";
NSString* const AVMetadataID3MetadataKeyPerformerSortOrder = @"AVMetadataID3MetadataKeyPerformerSortOrder";
NSString* const AVMetadataID3MetadataKeyTitleSortOrder = @"AVMetadataID3MetadataKeyTitleSortOrder";
NSString* const AVMetadataID3MetadataKeyInternationalStandardRecordingCode = @"AVMetadataID3MetadataKeyInternationalStandardRecordingCode";
NSString* const AVMetadataID3MetadataKeyEncodedWith = @"AVMetadataID3MetadataKeyEncodedWith";
NSString* const AVMetadataID3MetadataKeySetSubtitle = @"AVMetadataID3MetadataKeySetSubtitle";
NSString* const AVMetadataID3MetadataKeyYear = @"AVMetadataID3MetadataKeyYear";
NSString* const AVMetadataID3MetadataKeyUserText = @"AVMetadataID3MetadataKeyUserText";
NSString* const AVMetadataID3MetadataKeyUniqueFileIdentifier = @"AVMetadataID3MetadataKeyUniqueFileIdentifier";
NSString* const AVMetadataID3MetadataKeyTermsOfUse = @"AVMetadataID3MetadataKeyTermsOfUse";
NSString* const AVMetadataID3MetadataKeyUnsynchronizedLyric = @"AVMetadataID3MetadataKeyUnsynchronizedLyric";
NSString* const AVMetadataID3MetadataKeyCommercialInformation = @"AVMetadataID3MetadataKeyCommercialInformation";
NSString* const AVMetadataID3MetadataKeyCopyrightInformation = @"AVMetadataID3MetadataKeyCopyrightInformation";
NSString* const AVMetadataID3MetadataKeyOfficialAudioFileWebpage = @"AVMetadataID3MetadataKeyOfficialAudioFileWebpage";
NSString* const AVMetadataID3MetadataKeyOfficialArtistWebpage = @"AVMetadataID3MetadataKeyOfficialArtistWebpage";
NSString* const AVMetadataID3MetadataKeyOfficialAudioSourceWebpage = @"AVMetadataID3MetadataKeyOfficialAudioSourceWebpage";
NSString* const AVMetadataID3MetadataKeyOfficialInternetRadioStationHomepage =
    @"AVMetadataID3MetadataKeyOfficialInternetRadioStationHomepage";
NSString* const AVMetadataID3MetadataKeyPayment = @"AVMetadataID3MetadataKeyPayment";
NSString* const AVMetadataID3MetadataKeyOfficialPublisherWebpage = @"AVMetadataID3MetadataKeyOfficialPublisherWebpage";
NSString* const AVMetadataID3MetadataKeyUserURL = @"AVMetadataID3MetadataKeyUserURL";
NSString* const AVMetadataiTunesMetadataKeyAlbum = @"AVMetadataiTunesMetadataKeyAlbum";
NSString* const AVMetadataiTunesMetadataKeyArtist = @"AVMetadataiTunesMetadataKeyArtist";
NSString* const AVMetadataiTunesMetadataKeyUserComment = @"AVMetadataiTunesMetadataKeyUserComment";
NSString* const AVMetadataiTunesMetadataKeyCoverArt = @"AVMetadataiTunesMetadataKeyCoverArt";
NSString* const AVMetadataiTunesMetadataKeyCopyright = @"AVMetadataiTunesMetadataKeyCopyright";
NSString* const AVMetadataiTunesMetadataKeyReleaseDate = @"AVMetadataiTunesMetadataKeyReleaseDate";
NSString* const AVMetadataiTunesMetadataKeyEncodedBy = @"AVMetadataiTunesMetadataKeyEncodedBy";
NSString* const AVMetadataiTunesMetadataKeyPredefinedGenre = @"AVMetadataiTunesMetadataKeyPredefinedGenre";
NSString* const AVMetadataiTunesMetadataKeyUserGenre = @"AVMetadataiTunesMetadataKeyUserGenre";
NSString* const AVMetadataiTunesMetadataKeySongName = @"AVMetadataiTunesMetadataKeySongName";
NSString* const AVMetadataiTunesMetadataKeyTrackSubTitle = @"AVMetadataiTunesMetadataKeyTrackSubTitle";
NSString* const AVMetadataiTunesMetadataKeyEncodingTool = @"AVMetadataiTunesMetadataKeyEncodingTool";
NSString* const AVMetadataiTunesMetadataKeyComposer = @"AVMetadataiTunesMetadataKeyComposer";
NSString* const AVMetadataiTunesMetadataKeyAlbumArtist = @"AVMetadataiTunesMetadataKeyAlbumArtist";
NSString* const AVMetadataiTunesMetadataKeyAccountKind = @"AVMetadataiTunesMetadataKeyAccountKind";
NSString* const AVMetadataiTunesMetadataKeyAppleID = @"AVMetadataiTunesMetadataKeyAppleID";
NSString* const AVMetadataiTunesMetadataKeyArtistID = @"AVMetadataiTunesMetadataKeyArtistID";
NSString* const AVMetadataiTunesMetadataKeySongID = @"AVMetadataiTunesMetadataKeySongID";
NSString* const AVMetadataiTunesMetadataKeyDiscCompilation = @"AVMetadataiTunesMetadataKeyDiscCompilation";
NSString* const AVMetadataiTunesMetadataKeyDiscNumber = @"AVMetadataiTunesMetadataKeyDiscNumber";
NSString* const AVMetadataiTunesMetadataKeyGenreID = @"AVMetadataiTunesMetadataKeyGenreID";
NSString* const AVMetadataiTunesMetadataKeyGrouping = @"AVMetadataiTunesMetadataKeyGrouping";
NSString* const AVMetadataiTunesMetadataKeyPlaylistID = @"AVMetadataiTunesMetadataKeyPlaylistID";
NSString* const AVMetadataiTunesMetadataKeyContentRating = @"AVMetadataiTunesMetadataKeyContentRating";
NSString* const AVMetadataiTunesMetadataKeyBeatsPerMin = @"AVMetadataiTunesMetadataKeyBeatsPerMin";
NSString* const AVMetadataiTunesMetadataKeyTrackNumber = @"AVMetadataiTunesMetadataKeyTrackNumber";
NSString* const AVMetadataiTunesMetadataKeyArtDirector = @"AVMetadataiTunesMetadataKeyArtDirector";
NSString* const AVMetadataiTunesMetadataKeyArranger = @"AVMetadataiTunesMetadataKeyArranger";
NSString* const AVMetadataiTunesMetadataKeyAuthor = @"AVMetadataiTunesMetadataKeyAuthor";
NSString* const AVMetadataiTunesMetadataKeyLyrics = @"AVMetadataiTunesMetadataKeyLyrics";
NSString* const AVMetadataiTunesMetadataKeyAcknowledgement = @"AVMetadataiTunesMetadataKeyAcknowledgement";
NSString* const AVMetadataiTunesMetadataKeyConductor = @"AVMetadataiTunesMetadataKeyConductor";
NSString* const AVMetadataiTunesMetadataKeyDescription = @"AVMetadataiTunesMetadataKeyDescription";
NSString* const AVMetadataiTunesMetadataKeyDirector = @"AVMetadataiTunesMetadataKeyDirector";
NSString* const AVMetadataiTunesMetadataKeyEQ = @"AVMetadataiTunesMetadataKeyEQ";
NSString* const AVMetadataiTunesMetadataKeyLinerNotes = @"AVMetadataiTunesMetadataKeyLinerNotes";
NSString* const AVMetadataiTunesMetadataKeyRecordCompany = @"AVMetadataiTunesMetadataKeyRecordCompany";
NSString* const AVMetadataiTunesMetadataKeyOriginalArtist = @"AVMetadataiTunesMetadataKeyOriginalArtist";
NSString* const AVMetadataiTunesMetadataKeyPhonogramRights = @"AVMetadataiTunesMetadataKeyPhonogramRights";
NSString* const AVMetadataiTunesMetadataKeyProducer = @"AVMetadataiTunesMetadataKeyProducer";
NSString* const AVMetadataiTunesMetadataKeyPerformer = @"AVMetadataiTunesMetadataKeyPerformer";
NSString* const AVMetadataiTunesMetadataKeyPublisher = @"AVMetadataiTunesMetadataKeyPublisher";
NSString* const AVMetadataiTunesMetadataKeySoundEngineer = @"AVMetadataiTunesMetadataKeySoundEngineer";
NSString* const AVMetadataiTunesMetadataKeySoloist = @"AVMetadataiTunesMetadataKeySoloist";
NSString* const AVMetadataiTunesMetadataKeyCredits = @"AVMetadataiTunesMetadataKeyCredits";
NSString* const AVMetadataiTunesMetadataKeyThanks = @"AVMetadataiTunesMetadataKeyThanks";
NSString* const AVMetadataiTunesMetadataKeyOnlineExtras = @"AVMetadataiTunesMetadataKeyOnlineExtras";
NSString* const AVMetadataiTunesMetadataKeyExecProducer = @"AVMetadataiTunesMetadataKeyExecProducer";
NSString* const AVMetadataQuickTimeUserDataKeyAlbum = @"AVMetadataQuickTimeUserDataKeyAlbum";
NSString* const AVMetadataQuickTimeUserDataKeyArranger = @"AVMetadataQuickTimeUserDataKeyArranger";
NSString* const AVMetadataQuickTimeUserDataKeyArtist = @"AVMetadataQuickTimeUserDataKeyArtist";
NSString* const AVMetadataQuickTimeUserDataKeyAuthor = @"AVMetadataQuickTimeUserDataKeyAuthor";
NSString* const AVMetadataQuickTimeUserDataKeyChapter = @"AVMetadataQuickTimeUserDataKeyChapter";
NSString* const AVMetadataQuickTimeUserDataKeyComment = @"AVMetadataQuickTimeUserDataKeyComment";
NSString* const AVMetadataQuickTimeUserDataKeyComposer = @"AVMetadataQuickTimeUserDataKeyComposer";
NSString* const AVMetadataQuickTimeUserDataKeyCopyright = @"AVMetadataQuickTimeUserDataKeyCopyright";
NSString* const AVMetadataQuickTimeUserDataKeyCreationDate = @"AVMetadataQuickTimeUserDataKeyCreationDate";
NSString* const AVMetadataQuickTimeUserDataKeyDescription = @"AVMetadataQuickTimeUserDataKeyDescription";
NSString* const AVMetadataQuickTimeUserDataKeyDirector = @"AVMetadataQuickTimeUserDataKeyDirector";
NSString* const AVMetadataQuickTimeUserDataKeyDisclaimer = @"AVMetadataQuickTimeUserDataKeyDisclaimer";
NSString* const AVMetadataQuickTimeUserDataKeyEncodedBy = @"AVMetadataQuickTimeUserDataKeyEncodedBy";
NSString* const AVMetadataQuickTimeUserDataKeyFullName = @"AVMetadataQuickTimeUserDataKeyFullName";
NSString* const AVMetadataQuickTimeUserDataKeyGenre = @"AVMetadataQuickTimeUserDataKeyGenre";
NSString* const AVMetadataQuickTimeUserDataKeyHostComputer = @"AVMetadataQuickTimeUserDataKeyHostComputer";
NSString* const AVMetadataQuickTimeUserDataKeyInformation = @"AVMetadataQuickTimeUserDataKeyInformation";
NSString* const AVMetadataQuickTimeUserDataKeyKeywords = @"AVMetadataQuickTimeUserDataKeyKeywords";
NSString* const AVMetadataQuickTimeUserDataKeyMake = @"AVMetadataQuickTimeUserDataKeyMake";
NSString* const AVMetadataQuickTimeUserDataKeyModel = @"AVMetadataQuickTimeUserDataKeyModel";
NSString* const AVMetadataQuickTimeUserDataKeyOriginalArtist = @"AVMetadataQuickTimeUserDataKeyOriginalArtist";
NSString* const AVMetadataQuickTimeUserDataKeyOriginalFormat = @"AVMetadataQuickTimeUserDataKeyOriginalFormat";
NSString* const AVMetadataQuickTimeUserDataKeyOriginalSource = @"AVMetadataQuickTimeUserDataKeyOriginalSource";
NSString* const AVMetadataQuickTimeUserDataKeyPerformers = @"AVMetadataQuickTimeUserDataKeyPerformers";
NSString* const AVMetadataQuickTimeUserDataKeyProducer = @"AVMetadataQuickTimeUserDataKeyProducer";
NSString* const AVMetadataQuickTimeUserDataKeyPublisher = @"AVMetadataQuickTimeUserDataKeyPublisher";
NSString* const AVMetadataQuickTimeUserDataKeyProduct = @"AVMetadataQuickTimeUserDataKeyProduct";
NSString* const AVMetadataQuickTimeUserDataKeySoftware = @"AVMetadataQuickTimeUserDataKeySoftware";
NSString* const AVMetadataQuickTimeUserDataKeySpecialPlaybackRequirements = @"AVMetadataQuickTimeUserDataKeySpecialPlaybackRequirements";
NSString* const AVMetadataQuickTimeUserDataKeyTrack = @"AVMetadataQuickTimeUserDataKeyTrack";
NSString* const AVMetadataQuickTimeUserDataKeyWarning = @"AVMetadataQuickTimeUserDataKeyWarning";
NSString* const AVMetadataQuickTimeUserDataKeyWriter = @"AVMetadataQuickTimeUserDataKeyWriter";
NSString* const AVMetadataQuickTimeUserDataKeyURLLink = @"AVMetadataQuickTimeUserDataKeyURLLink";
NSString* const AVMetadataQuickTimeUserDataKeyLocationISO6709 = @"AVMetadataQuickTimeUserDataKeyLocationISO6709";
NSString* const AVMetadataQuickTimeUserDataKeyTrackName = @"AVMetadataQuickTimeUserDataKeyTrackName";
NSString* const AVMetadataQuickTimeUserDataKeyCredits = @"AVMetadataQuickTimeUserDataKeyCredits";
NSString* const AVMetadataQuickTimeUserDataKeyPhonogramRights = @"AVMetadataQuickTimeUserDataKeyPhonogramRights";
NSString* const AVMetadataQuickTimeUserDataKeyTaggedCharacteristic = @"AVMetadataQuickTimeUserDataKeyTaggedCharacteristic";
NSString* const AVMetadataQuickTimeMetadataKeyCameraIdentifier = @"AVMetadataQuickTimeMetadataKeyCameraIdentifier";
NSString* const AVMetadataQuickTimeMetadataKeyCameraFrameReadoutTime = @"AVMetadataQuickTimeMetadataKeyCameraFrameReadoutTime";
NSString* const AVMetadataQuickTimeMetadataKeyTitle = @"AVMetadataQuickTimeMetadataKeyTitle";
NSString* const AVMetadataQuickTimeMetadataKeyCollectionUser = @"AVMetadataQuickTimeMetadataKeyCollectionUser";
NSString* const AVMetadataQuickTimeMetadataKeyRatingUser = @"AVMetadataQuickTimeMetadataKeyRatingUser";
NSString* const AVMetadataQuickTimeMetadataKeyLocationName = @"AVMetadataQuickTimeMetadataKeyLocationName";
NSString* const AVMetadataQuickTimeMetadataKeyLocationBody = @"AVMetadataQuickTimeMetadataKeyLocationBody";
NSString* const AVMetadataQuickTimeMetadataKeyLocationNote = @"AVMetadataQuickTimeMetadataKeyLocationNote";
NSString* const AVMetadataQuickTimeMetadataKeyLocationRole = @"AVMetadataQuickTimeMetadataKeyLocationRole";
NSString* const AVMetadataQuickTimeMetadataKeyLocationDate = @"AVMetadataQuickTimeMetadataKeyLocationDate";
NSString* const AVMetadataQuickTimeMetadataKeyDirectionFacing = @"AVMetadataQuickTimeMetadataKeyDirectionFacing";
NSString* const AVMetadataQuickTimeMetadataKeyDirectionMotion = @"AVMetadataQuickTimeMetadataKeyDirectionMotion";
NSString* const AVMetadataISOUserDataKeyCopyright = @"AVMetadataISOUserDataKeyCopyright";
NSString* const AVMetadata3GPUserDataKeyCopyright = @"AVMetadata3GPUserDataKeyCopyright";
NSString* const AVMetadata3GPUserDataKeyAuthor = @"AVMetadata3GPUserDataKeyAuthor";
NSString* const AVMetadata3GPUserDataKeyPerformer = @"AVMetadata3GPUserDataKeyPerformer";
NSString* const AVMetadata3GPUserDataKeyGenre = @"AVMetadata3GPUserDataKeyGenre";
NSString* const AVMetadata3GPUserDataKeyRecordingYear = @"AVMetadata3GPUserDataKeyRecordingYear";
NSString* const AVMetadata3GPUserDataKeyLocation = @"AVMetadata3GPUserDataKeyLocation";
NSString* const AVMetadata3GPUserDataKeyTitle = @"AVMetadata3GPUserDataKeyTitle";
NSString* const AVMetadata3GPUserDataKeyDescription = @"AVMetadata3GPUserDataKeyDescription";
NSString* const AVMetadataQuickTimeMetadataKeyAuthor = @"AVMetadataQuickTimeMetadataKeyAuthor";
NSString* const AVMetadataQuickTimeMetadataKeyComment = @"AVMetadataQuickTimeMetadataKeyComment";
NSString* const AVMetadataQuickTimeMetadataKeyCopyright = @"AVMetadataQuickTimeMetadataKeyCopyright";
NSString* const AVMetadataQuickTimeMetadataKeyCreationDate = @"AVMetadataQuickTimeMetadataKeyCreationDate";
NSString* const AVMetadataQuickTimeMetadataKeyDirector = @"AVMetadataQuickTimeMetadataKeyDirector";
NSString* const AVMetadataQuickTimeMetadataKeyDisplayName = @"AVMetadataQuickTimeMetadataKeyDisplayName";
NSString* const AVMetadataQuickTimeMetadataKeyInformation = @"AVMetadataQuickTimeMetadataKeyInformation";
NSString* const AVMetadataQuickTimeMetadataKeyKeywords = @"AVMetadataQuickTimeMetadataKeyKeywords";
NSString* const AVMetadataQuickTimeMetadataKeyProducer = @"AVMetadataQuickTimeMetadataKeyProducer";
NSString* const AVMetadataQuickTimeMetadataKeyPublisher = @"AVMetadataQuickTimeMetadataKeyPublisher";
NSString* const AVMetadataQuickTimeMetadataKeyAlbum = @"AVMetadataQuickTimeMetadataKeyAlbum";
NSString* const AVMetadataQuickTimeMetadataKeyArtist = @"AVMetadataQuickTimeMetadataKeyArtist";
NSString* const AVMetadataQuickTimeMetadataKeyArtwork = @"AVMetadataQuickTimeMetadataKeyArtwork";
NSString* const AVMetadataQuickTimeMetadataKeyDescription = @"AVMetadataQuickTimeMetadataKeyDescription";
NSString* const AVMetadataQuickTimeMetadataKeySoftware = @"AVMetadataQuickTimeMetadataKeySoftware";
NSString* const AVMetadataQuickTimeMetadataKeyYear = @"AVMetadataQuickTimeMetadataKeyYear";
NSString* const AVMetadataQuickTimeMetadataKeyGenre = @"AVMetadataQuickTimeMetadataKeyGenre";
NSString* const AVMetadataQuickTimeMetadataKeyiXML = @"AVMetadataQuickTimeMetadataKeyiXML";
NSString* const AVMetadataQuickTimeMetadataKeyLocationISO6709 = @"AVMetadataQuickTimeMetadataKeyLocationISO6709";
NSString* const AVMetadataQuickTimeMetadataKeyMake = @"AVMetadataQuickTimeMetadataKeyMake";
NSString* const AVMetadataQuickTimeMetadataKeyModel = @"AVMetadataQuickTimeMetadataKeyModel";
NSString* const AVMetadataQuickTimeMetadataKeyArranger = @"AVMetadataQuickTimeMetadataKeyArranger";
NSString* const AVMetadataQuickTimeMetadataKeyEncodedBy = @"AVMetadataQuickTimeMetadataKeyEncodedBy";
NSString* const AVMetadataQuickTimeMetadataKeyOriginalArtist = @"AVMetadataQuickTimeMetadataKeyOriginalArtist";
NSString* const AVMetadataQuickTimeMetadataKeyPerformer = @"AVMetadataQuickTimeMetadataKeyPerformer";
NSString* const AVMetadataQuickTimeMetadataKeyComposer = @"AVMetadataQuickTimeMetadataKeyComposer";
NSString* const AVMetadataQuickTimeMetadataKeyCredits = @"AVMetadataQuickTimeMetadataKeyCredits";
NSString* const AVMetadataQuickTimeMetadataKeyPhonogramRights = @"AVMetadataQuickTimeMetadataKeyPhonogramRights";

/**
@Status Stub
@Notes
*/
CGRect AVMakeRectWithAspectRatioInsideRect(CGSize aspectRatio, CGRect boundingRect) {
    UNIMPLEMENTED();
    return StubReturn();
}
